<?php

/*
 * Created on Mar 14, 2007
 * By Paul Leung
 * 
 * 
 * Classes that used to operate one ldap schema file
 */
class sqlBind {
	var $sql;
	function sqlBind($sql, $parm) {
		$this->fillValues($sql, $parm);
	}
	function setSQL($sql) {
		$this->sqlBind($sql);
	}
	function fillValues($sql, $list) {
		foreach ($list as $key => $value) {
			$sql = preg_replace($value['hole'], $value['key'], $sql);
		}
		return $sql;
	}
	function insert($table, $fields, $values) {
		$parm = array (
			0 => array (
				'hole' => '/%table%/',
				'key' => $table
			),
			1 => array (
				'hole' => '/%fields%/',
				'key' => $fields
			),
			3 => array (
				'hole' => '/%values%/',
				'key' => $values
			)
		);
		return sqlBind :: fillValues(sqlConfig :: $insert, $parm);
	}
	function delete($table, $condition) {
		$parm = array (
			0 => array (
				'hole' => '/%table%/',
				'key' => $table
			),
			1 => array (
				'hole' => '/%cond%/',
				'key' => $condition
			)
		);
		return sqlBind :: fillValues(sqlConfig :: $delete, $parm);
	}
}

class scheamFiles {
	var $schemas = array ();
	function scheamFiles($list) {
		$temp = $this->readSchemaFiles($list);
		$this->schemas = $this->phase($temp);
	}
	function readSchemaFiles($schemafiles) {
		$result = '';
		foreach ($schemafiles as $key => $schemaFile) {
			$fp = fopen('./schema/' . $schemaFile, 'rb');
			$result .= fread($fp, filesize('./schema/' . $schemaFile));
			fclose($fp);
		}
		return $result;
	}
	function phase($schemas) {
		//remove all comment and multiple \n
		$schemas;
		$schemas = preg_replace('/(#.*\n)|((\/\*)(.*(\n)+)*(\*\/))|$(\n)/', '', $schemas);
		//remove new line and tab with space
		$schemas = preg_replace('/[\n|\t]/', " ", $schemas);
		//replace extrace space with one space
		$schemas = preg_replace('/( )+/', ' ', $schemas);
		$schemas = preg_replace('/objectidentifier( )+/i', '^^^objectidentifier ', $schemas);
		$schemas = preg_replace('/objectclass[^\']( )*\(/i', '^^^objectclass (', $schemas);
		$schemas = preg_replace('/attributetype/', '^^^attributetype', $schemas);
		$schemas = substr($schemas, 4);
		return preg_split('/\^\^\^/', $schemas);
	}
}

class itemOperation {
	var $schema = '';
	var $metadataSQL = '';
	var $tableSQL = '';
	var $functionSQL = '';
	var $type = '';
	var $MAY = array ();
	var $MUST = array ();
	var $dataType = '';
	var $dataLength = '';
	var $NAME = '';
	var $Parent = '';
	var $ParentAttr = array ();
	var $Single = false;
	var $repeated = false;
	var $nodeType = '';
	var $AUX = false;
	var $childs = array ();
	function setSchema($s) {
		$s = preg_replace('/\n/', '', $s);
		$this->schema = preg_replace('/\t/', ' ', $s);
	}
	function itemOperation($s) {
		if ($s != '')
			$this->setSchema($s);
		$this->processSchema();
	}
	function checkType() {
		if (strtoupper(substr($this->schema, 0, 11)) == 'OBJECTCLASS') {
			$this->type = 'objectclass';
		}
		elseif (strtoupper(substr($this->schema, 0, 11)) == 'ATTRIBUTETY') {
			$this->type = 'attributetype';
		}
		elseif (strtoupper(substr($this->schema, 0, 11)) == 'OBJECTIDENT') {
			$this->type = 'objectidentifier';
		}
	}
	function processSchema() {
		$this->checkType();
		if ($this->type == 'objectclass') {
			$this->getName();
			$this->getMUST();
			$this->getMAY();
			$this->getStructParent();
			$this->checkNode();
		}
		elseif ($this->type == 'attributetype') {
			$this->getName();
			$this->getDataType();
			$this->getStructParent();
			$this->checkSingle();
		}
		elseif ($this->type == 'objectidentifier') {
			$this->processIdentifier();
		}
	}
	function getItemAttr($attrName) {
		$exists = -1;
		$result = preg_replace('/.*' . $attrName . '( )+(\(){0,}( ){0,}/', '', $this->schema, -1, $exists);
		if ($exists > 0) {
			$result = preg_replace('/( )+\$( )+/', '\$', $result);
			$result = preg_replace('/( )+\w.*|( )+\).*/', '', $result);
			return preg_split('/\$/', $result);
		} else {
			return array ();
		}
	}
	function getMUST() {
		$this->MUST = $this->getItemAttr('MUST');
	}
	function getMAY() {
		$this->MAY = $this->getItemAttr('MAY');
	}
	function getDataType() {
		$result = preg_replace('/.*SYNTAX( )*/', '', $this->schema, -1, $exists);
		if ($exists > 0) {
			$result = preg_replace('/( )+.*/', '}', $result);
			$result = preg_split('/(\{|\})/', $result);
			$this->dataType = $result[0];
			$this->dataLength = $result[1];
		} else {
			$result = preg_replace('/.*SUP( )+/', '', $this->schema, -1, $exists);
			$this->dataType = preg_replace('/ (\w|\)).*/', '', $result);
		}
	}
	function getName() {
		$result = preg_replace('/.*NAME( )+(\(){0,}( ){0,}\'/', '\'', $this->schema);
		$result = preg_replace('/\' +[\w|\)].*/', '\'', $result);
		$result = preg_replace('/\'/', '', $result);
		$this->NAME = preg_split('/ /', $result);
	}
	function processIdentifier() {
		$temp = preg_split('/ /', $this->schema);
		$this->NAME = array (
			$temp[1]
		);
		$this->dataType = $temp[2];
	}
	function getStructParent() {
		$result = preg_replace('/.*SUP( )+/', '', $this->schema, -1, $exists);
		if ($exists > 0) {
			$this->Parent = preg_replace('/ +(\w|\)).*/', '', $result);
		} else {
			$this->Parent = '';
		}
	}
	function appendStruct($Obj_or_Attr) {
		"appendStruct " . $Obj_or_Attr . " ? \n<br>";
		$this->dataLength = $Obj_or_Attr->dataLength;
		$this->dataType = $Obj_or_Attr->dataType;
		foreach ($Obj_or_Attr->MAY as $key => $may) {
			$this->MAY[] = $may;
		}
		foreach ($Obj_or_Attr->MUST as $key => $must) {
			$this->MUST[] = $must;
		}
	}
	function checkSingle() {
		preg_replace('/SINGLE-VALUE/', '', $this->schema, -1, $exists);
		if ($exists > 0) {
			$this->Single = true;
		} else {
			$this->Single = false;
		}
	}
	function checkNode() {
		preg_replace('/AUXILIARY/i', '', $this->schema, -1, $exists);
		if ($exists > 0) {
			$this->nodeType = 'AUX';
			return;
		}
		preg_replace('/ABSTRACT/i', '', $this->schema, -1, $exists);
		if ($exists > 0) {
			$this->nodeType = 'ABS';
			return;
		}
		preg_replace('/STRUCTURAL/i', '', $this->schema, -1, $exists);
		if ($exists > 0) {
			$this->nodeType = 'STRU';
			return;
		}
	}
}

class schemaDict {
	/*1 fill objectclass MAY & MUST from their parent class
	 *2 fill SYNTAX with parent attribute
	 */
	var $dict_Attr = array ();
	var $dict_OC = array ();
	var $dict_AUX = array ();
	var $dict_ABS = array ();
	var $dict_ID = array ();
	var $AUXattrs = array ();

	var $backsql_noAUX = true;
	var $tree = '';

	function schemaDict($i = null) {
	}

	function setItems($i) {
		$this->fillEmptyDict($i);
	}
	function inheritParent() {
		foreach ($this->dict_OC as $key => $item) {
			$item->ParentAttr = $this->listParentAttrs($item);
			//			$this->getParent($item, $this->dict_OC);
		}
		foreach ($this->dict_Attr as $key => $item) {
			$item->ParentAttr = $this->listParentAttrs($item);
		}
	}
	function finallize() {
		$this->checkAttrsCase();
		$this->inheritParent();
		$this->AUXattrs = $this->listAUXABSAttrs();
		foreach ($this->dict_OC as $key => $oc) {
			$this->OCFunction($oc);
			$this->table($oc);
			$this->metadata($oc);
		}
		foreach ($this->dict_AUX as $key => $oc) {
			$this->table($oc);
		}
		foreach ($this->dict_ABS as $key => $oc) {
			$this->table($oc);
		}
		foreach ($this->dict_Attr as $key => $attr) {
			$this->table($attr);
			$this->metadata($attr);
		}
	}
	function fillEmptyDict($items) {
		$this->dict_Attr = array ();
		$this->dict_OC = array ();
		foreach ($items as $key => $item) {
			if ($item->type == 'attributetype') {
				$this->dict_Attr[] = $item;
			}
			elseif ($item->type == 'objectclass') {
				if ($item->nodeType == 'STRU') {
					$this->dict_OC[] = $item;
				}
				elseif ($item->nodeType == 'ABS') {
					$this->dict_ABS[] = $item;
				}
				elseif ($item->nodeType == 'AUX') {
					$this->dict_AUX[] = $item;
				}
			}
			elseif ($item->type == 'objectidentifier') {
				$this->dict_ID[] = $item;
			}
		}
	}
	function appendItem($item) {
		if ($item->type == 'attributetype') {
			if ($this->searchList($item->NAME[0], $this->dict_Attr) == -1) {
				$this->dict_Attr[] = $item;
			}
		}
		elseif ($item->type == 'objectclass') {
			if ($this->searchList($item->NAME[0], $this->dict_OC) == -1) {
				if ($item->nodeType == 'STRU') {
					$this->dict_OC[] = $item;
				}
				elseif ($item->nodeType == 'ABS') {
					$this->dict_ABS[] = $item;
				}
				elseif ($item->nodeType == 'AUX') {
					$this->dict_AUX[] = $item;
				}
			}
		}
		elseif ($item->type == 'objectidentifier') {
			if ($this->searchList($item->NAME[0], $this->dict_OC) == -1) {
				$this->dict_ID[] = $item;
			}
		}
	}
	function searchList($searchFor, $list) {
		foreach ($list as $key => $item) {
			foreach ($item->NAME as $NAME)
				if (strtoupper($searchFor) == strtoupper($NAME)) {
					return $key;
				}
		}
		return -1;
	}
	function getParent($item, $list, & $Attrlist = null) {
		if ($item->Parent != '' && $item->Parent != 'top') {
			$key = $this->searchList($item->Parent, $list);
			if ($key != -1) {
				$thisParent = $this->getParent($list[$key], $list, $Attrlist);
				if ($list != null) {
					$Attrlist = $this->appendAttrList($thisParent, $Attrlist);
				} else {
					$item->appendStruct($thisParent);
				}
				return $item;
			} else {
				return $item;
				//Parent is not in this dictionary
			}
		} else {
			return $item;
		}
	}
	function printObject($obj) {
		$delim = "\n";
		echo "============================================================" . $delim;
		echo "   SCHEMA = " . $obj->schema . $delim;
		echo "   TYPE = " . $obj->type . $delim;
		echo "   NAME = " . $delim;
		print_r($obj->NAME);
		echo "   Parent = " . $obj->Parent . $delim;
		if ($obj->type == 'objectclass') {
			echo "   MUST = " . $delim;
			print_r($obj->MUST);
			echo "   MAY = " . $delim;
			print_r($obj->MAY);
			echo "   Parent ATTR " . $delim;
			//		print_r($this->listParentAttrs($obj));
			print_r($obj->ParentAttr);
		} else {
			echo "   SYNTAX = " . $obj->dataType . $delim;
			echo "   datalength = " . $obj->dataLength . $delim;
			echo "   Single Value = " . $obj->Single . $delim;
		}
	}
	function listDict() {
		foreach ($this->dict_OC as $key => $oc) {
			$this->printObject($oc);
		}
		foreach ($this->dict_Attr as $key => $attr) {
			$this->printObject($attr);
		}
		foreach ($this->dict_ID as $key => $id) {
			$this->printObject($id);
		}
	}
	function appendAttrList($obj, $list) {
		foreach ($obj->MAY as $key => $attr) {
			$list['MAY']['parent'][] = $obj->NAME[0];
			$list['MAY']['attr'][] = $attr;
		}
		foreach ($obj->MUST as $key => $attr) {
			$list['MUST']['parent'][] = $obj->NAME[0];
			$list['MUST']['attr'][] = $attr;
		}
		$list['SYNTAX'] = $obj->dataType;
		return $list;
	}
	function listParentAttrs($obj) {
		$attr_list = array (
			'MAY' => array (
				'parent' => array (),
				'attr' => array ()
			),
			'MUST' => array (
				'parent' => array (),
				'attr' => array ()
			),
			'SYNTAX' => ''
		);
		if ($obj->type == 'objectclass')
			$this->getParent($obj, $this->dict_OC, $attr_list);
		if ($obj->type == 'attributetype')
			$this->getParent($obj, $this->dict_Attr, $attr_list);
		return $attr_list;
	}
	function listSingleAttrs($obj) {
		$result = array ();

		foreach ($obj->MAY as $may) {
			$key = $this->searchList($may, $this->dict_Attr);
			if ($key != -1 && $this->dict_Attr[$key]->Single == true) {
				$result = $this->chkRepeat($result, $key);
			}
		}
		if ($obj->ParentAttr != null)
			foreach ($obj->ParentAttr['MAY']['attr'] as $may) {
				$key = $this->searchList($may, $this->dict_Attr);
				if ($key != -1 && $this->dict_Attr[$key]->Single == true) {
					$result = $this->chkRepeat($result, $key);
				}
			}
		foreach ($obj->MUST as $must) {
			$key = $this->searchList($must, $this->dict_Attr);
			if ($key != -1 && $this->dict_Attr[$key]->Single == true) {
				$result = $this->chkRepeat($result, $key);
			}
		}
		if ($obj->ParentAttr != null)
			foreach ($obj->ParentAttr['MUST']['attr'] as $must) {
				$key = $this->searchList($must, $this->dict_Attr);
				if ($key != -1 && $this->dict_Attr[$key]->Single == true) {
					$result = $this->chkRepeat($result, $key);
				}
			}
		return $result;
	}
	function chkRepeat($list, $val, $mode = 'D') {
		$result = array ();
		$repeat = false;
		if (sizeof($list) == 0) {
			$result[] = $val;
			return $result;
		} else {
			foreach ($list as $item) {
				if ($item != $val) {
					$result[] = $item;
				} else {
					$repeat = true;
					$this->dict_Attr[$item]->repeated = true;
				}
			}
			if (!$repeat || strtoupper($mode) == 'RO') {
				$result[] = $val;
			}
			return $result;
		}
	}
	function normAttrs($addList, & $resultList = null, $mode = 'RO' /* repeatOnce, repeat, drop repeat*/
	, & $repeatList = array ()) {
		$result = array ();
		if ($resultList == null)
			$resultList = array ();
		$added = array_merge($addList, $resultList);
		foreach ($added as $attr) {
			$repeat = false;
			$repeatList[$attr] = 0;
			foreach ($result as $key => $inListAttr) {
				if ($inListAttr == $attr) {
					$repeat = true;
					$repeatList[$attr]++;
					if (strtoupper($mode) == 'D') {
						$result[$key] = null;
					}
					continue 2;
				}
			}
			if (!$repeat && strtoupper($mode) == 'RO') {
				$result[] = $attr;
			}
		}
		if (strtoupper($mode) == 'RO') {
			return $resultList = $result;
		}
		elseif (strtoupper($mode) == 'D') {
			$tmp = array ();
			foreach ($result as $attr)
				if ($attr != null)
					$tmp[] = $attr;
			return $resultList = $tmp;
		}
		elseif (strtoupper($mode) == 'R') {
			return $resultList = $added;
		}
	}
	function metadata($obj) {
		if ($obj->type == 'objectclass' && $obj->nodeType == 'STRU') {
			$parm = array (
				0 => array (
					'hole' => '/%table%/',
					'key' => sqlConfig :: $table_oc_mappings
				),
				1 => array (
					'hole' => '/%fields%/',
					'key' => sqlConfig :: $ldap_oc_mappings_fields
				),
					//id, name, keytbl, keycol, create_proc, delete_proc, expect_return)
	3 => array (
					'hole' => '/%values%/',
					'key' => "'', '" . $obj->NAME[0] . "', '`" . $obj->NAME[0] . "`', '`id`', 'SELECT add_" . $obj->NAME[0] . "()', \"SELECT del_" . $obj->NAME[0] . "(?)\", 0"
				)
			);
			$obj->metadataSQL .= sqlBind :: fillValues(sqlConfig :: $insert, $parm) . sqlConfig :: $sqlclient_delim . "\n";
			$obj->metadataSQL .= sqlConfig :: $collect_last_id . sqlConfig :: $sqlclient_delim . "\n";
			$attrList = array_merge($obj->MUST, $obj->MAY, $obj->ParentAttr['MUST']['attr'], $obj->ParentAttr['MAY']['attr']);
			$obj->metadataSQL .= $this->insertAttr($attrList, $obj->NAME[0]);
			if ($this->backsql_noAUX) {
				$obj->metadataSQL .= $this->insertAttr($this->attr_diff($this->AUXattrs, $attrList), $obj->NAME[0]);
			} else {
				//If AUX attr is automatically supported then only it's attrs & parent struct attrs is needed 
			}
		}
		elseif ($obj->type == 'attributetype') {
		}
	}

	function attr_diff($inList, $dropThis) {
		$result = array ();
		foreach ($inList as $attr) {
			$repeat = false;
			$key = $this->searchList($attr, $this->dict_Attr);
			foreach ($dropThis as $dropAttr) {
				if ($key == $this->searchList($dropAttr, $this->dict_Attr)) {
					$repeat = true;
				}
			}
			if (!$repeat) {
				$result[] = $this->dict_Attr[$key]->NAME[0];
			}
		}
		return $result;
	}
	function checkAttrsCase() {
		$OCLists = array (
			0 => & $this->dict_OC,
			1 => & $this->dict_AUX,
			2 => & $this->dict_ABS
		);
		foreach ($OCLists as $key1 => $OCList) {
			foreach ($OCList as $key2 => $OC) {
				$AttrLists = array (
					0 => & $OCLists[$key1][$key2]->MAY,
					1 => & $OCLists[$key1][$key2]->MUST
				);
				foreach ($AttrLists as $key3 => $AttrList) {
					foreach ($AttrList as $key4 => $Attr) {
						$AttrLists[$key3][$key4] = $this->normAttrCase($Attr);
					}
				}
			}
		}
	}

	function normAttrCase($chkAttr) {
		foreach ($this->dict_Attr as $attr) {
			foreach ($attr->NAME as $target) {
				if (strtoupper($chkAttr) == strtoupper($target) && $chkAttr != $target) {
					return $target;
				}
				elseif ($chkAttr == $target) {
					return $target;
				}
			}
		}
	}

	function listObjAttrs($obj, $list = null) {
		if ($list == null) {
			$resultList = array ();
		} else {
			$resultList = $list;
		}
		$attrlists = array (
			0 => $obj->MAY,
			1 => $obj->MUST
		);
		foreach ($attrlists as $attrs) {
			foreach ($attrs as $attr) {
				foreach ($resultList as $inListVal) {
					if ($inListVal == $attr)
						continue 2;
				}
				$resultList[] = $attr;
			}
		}
		return $resultList;
	}

	function listAUXABSAttrs($list = null) {
		if ($list == null) {
			$resultList = array ();
		} else {
			$resultList = $list;
		}
		$dicts = array (
			0 => $this->dict_ABS,
			1 => $this->dict_AUX
		);
		foreach ($dicts as $key => $dict) {
			foreach ($dict as $obj) {
				$attrlists = array (
					0 => $obj->MAY,
					1 => $obj->MUST
				);
				foreach ($attrlists as $attrs) {
					foreach ($attrs as $attr) {
						foreach ($resultList as $inListVal) {
							if ($inListVal == $attr) {
							}
						}
						$key = $this->searchList($attr, $this->dict_Attr);
						$this->dict_Attr[$key]->AUX = true;
						$resultList[] = $attr;
					}
				}
			}
		}
		$resultList = $this->normAttrs($resultList);
		return $resultList;
	}
	function table($item, $ignoreExists = false) {
		if (!$ignoreExists) {
			$skip = '';
			$vskip = '';
		} else {
			$skip = sqlConfig :: $ifNotExists;
			$vskip = sqlConfig :: $orReplace;
		}
		if ($item->type == 'objectclass') {
			$normFields = "";
			foreach ($this->listSingleAttrs($item) as $attrKeys) {
				$attr = $this->dict_Attr[$attrKeys];
				preg_replace('/SUP/', '', $attr->schema, -1, $exists);
				if ($exists > 0) {
					$dataType = $attr->ParentAttr['SYNTAX'];
				} else {
					$dataType = $attr->dataType;
				}
				$normFields .= ",\n" . $attr->NAME[0] . ' ' . syntax :: $datatype[$dataType]['datatype'] . ' ' . (syntax :: $datatype[$dataType]['charset'] != '' && syntax :: $datatype[$dataType]['charset'] != null ? 'CHARACTER SET ' . syntax :: $datatype[$dataType]['charset'] : '') . ' NULL ';
			}
			if ($item->nodeType == 'STRU') {
				$default_fields = sqlConfig :: $objectclass_default_fields;
			}
			elseif ($item->nodeType == 'AUX') {
				$default_fields = sqlConfig :: $attribute_default_fields;
			}
			elseif ($item->nodeType == 'ABS') {
				$default_fields = sqlConfig :: $attribute_default_fields;
			}
			$parm = array (
				0 => array (
					'hole' => '/%table%/',
					'key' => $item->NAME[0]
				),
				1 => array (
					'hole' => '/%default%/',
					'key' => $default_fields
				),
		//				check if there exists SINGLE-VALUE attributes
	2 => array (
					'hole' => '/%fields%/',
					'key' => ($normFields . "\n"
				)
			), 3 => array (
				'hole' => '/%ifNotExists%/',
				'key' => $skip
			));
			$item->tableSQL .= sqlBind :: fillValues(sqlConfig :: $create_table, $parm) . sqlConfig :: $sqlclient_delim . "\n";
		} else
			if ($item->type == 'attributetype') {
				if (!$item->Single || $item->repeated || $item->AUX) {
					preg_replace('/SUP/', '', $item->schema, -1, $exists);
					if ($exists > 0) {
						$dataType = $item->ParentAttr['SYNTAX'];
					} else {
						$dataType = $item->dataType;
					}
					$parm = array (
						0 => array (
							'hole' => '/%table%/',
							'key' => $item->NAME[0]
						),
						1 => array (
							'hole' => '/%default%/',
							'key' => sqlConfig :: $attribute_default_fields
						),
						2 => array (
							'hole' => '/%fields%/',
							'key' => ",\n`" . $item->NAME[0] . '` ' . syntax :: $datatype[$dataType]['datatype'] . ' ' . (syntax :: $datatype[$dataType]['charset'] != '' && syntax :: $datatype[$dataType]['charset'] != null ? 'CHARACTER SET ' . syntax :: $datatype[$dataType]['charset'] : ''
						) . " NULL\n"
					), 3 => array (
						'hole' => '/%ifNotExists%/',
						'key' => $skip
					));
					$item->tableSQL = sqlBind :: fillValues(sqlConfig :: $create_table, $parm) . sqlConfig :: $sqlclient_delim . "\n";
					for ($i = 1; $i < sizeof($item->NAME); $i++) {
						$parm = array (
							0 => array (
								'hole' => '/%table%/',
								'key' => $item->NAME[0]
							),
							1 => array (
								'hole' => '/%view%/',
								'key' => $item->NAME[$i]
							),
							2 => array (
								'hole' => '/%default_attr_fields%/',
								'key' => sqlConfig :: $default_attr_fields . ", "
							),
							3 => array (
								'hole' => '/%replace%/',
								'key' => $vskip
							)
						);
						$item->tableSQL .= sqlBind :: fillValues(sqlConfig :: $create_view, $parm) . sqlConfig :: $sqlclient_delim . "\n";
					}
				}
			}
	}
	function insertAttr($list, $ocName, $repeatList = array ()) {
		$result = '';
		$repeated = array ();
		foreach ($list as $attr) {
			foreach ($repeated as $chkVal) {
				if ($chkVal == $attr)
					continue 2;
			}
			$item = $this->dict_Attr[$this->searchList($attr, $this->dict_Attr)];
			$attr = $item->NAME[0];
			if ($item->Single != true || $item->repeated == true || $item->AUX) {
				$repeated[] = $attr;
				//  id,                   oc_map_id,    name, sel_expr, sel_expr_u,       from_tbls,                                           join_where,   add_proc, delete_proc, param_order, expect_return
				$values = "'', " . sqlConfig :: $var_last_id . ", '$attr',  '`$attr`',         '', '`$attr`,`$ocName`', \"`$attr`.`ref_id`=`$ocName`.`id` AND `$attr`.`ref_oc`='$ocName'\", \"CALL insertAttr(@id, '$attr', '$ocName', ?, ?)\", \"CALL deleteAttr(@id, '$attr', '$ocName', ?, ?)\", 3, 0";
			} else {
				//  id,                   oc_map_id,    name, sel_expr, sel_expr_u, from_tbls, join_where,   add_proc, delete_proc, param_order, expect_return
				$values = "'', " . sqlConfig :: $var_last_id . ", '$attr',  '`$attr`',         '', '`$ocName`',     'true', \"CALL insertSingleAttr(@id, '$attr', '$ocName', ?, ?)\", \"CALL deleteSingleAttr(@id, '$attr', '$ocName', ?, ?)\", 3, 0";
			}
			$parm = array (
				0 => array (
					'hole' => '/%table%/',
					'key' => sqlConfig :: $table_attr_mappings
				),
				1 => array (
					'hole' => '/%fields%/',
					'key' => sqlConfig :: $ldap_attr_mappings_fields
				),
				2 => array (
					'hole' => '/%ifNotExists%/',
					'key' => ''
				),
				3 => array (
					'hole' => '/%values%/',
					'key' => $values
				)
			);
			$result .= sqlBind :: fillValues(sqlConfig :: $insert, $parm) . sqlConfig :: $sqlclient_delim . "\n";
		}
		return $result;
	}
	function OCFunction($item) {
		$sqlcmds = sqlBind :: insert($item->NAME[0], "`id`", "null") . sqlConfig :: $sql_syntax_delim . "\n";
		$sqlcmds .= sqlConfig :: $return_last_insert_id . sqlConfig :: $sql_syntax_delim . "\n";
		$parm = array (
			0 => array (
				'hole' => '/%function%/',
				'key' => "add_" . $item->NAME[0]
			),
			1 => array (
				'hole' => '/%user%/',
				'key' => sqlConfig :: $ldap_setuser . sqlConfig :: $ldap_user
			),
			2 => array (
				'hole' => '/%parms%/',
				'key' => ''
			),
			3 => array (
				'hole' => '/%returnType%/',
				'key' => 'BIGINT'
			),
			4 => array (
				'hole' => '/%sqlcmd%/',
				'key' => $sqlcmds
			)
		);
		$item->functionSQL = sqlBind :: fillValues(sqlConfig :: $create_function, $parm) . sqlConfig :: $sqlclient_delim . "\n";

		$sqlcmds = sqlBind :: delete($item->NAME[0], "`id`=parm1") . sqlConfig :: $sql_syntax_delim . "\n";
		$sqlcmds .= "RETURN parm1" . sqlConfig :: $sql_syntax_delim . "\n";
		$parm = array (
			0 => array (
				'hole' => '/%function%/',
				'key' => "del_" . $item->NAME[0]
			),
			1 => array (
				'hole' => '/%user%/',
				'key' => sqlConfig :: $ldap_setuser . sqlConfig :: $ldap_user
			),
			2 => array (
				'hole' => '/%parms%/',
				'key' => 'parm1 BIGINT'
			),
			3 => array (
				'hole' => '/%returnType%/',
				'key' => 'BIGINT'
			),
			4 => array (
				'hole' => '/%sqlcmd%/',
				'key' => $sqlcmds
			)
		);
		$item->functionSQL .= sqlBind :: fillValues(sqlConfig :: $create_function, $parm) . sqlConfig :: $sqlclient_delim . "\n";
	}
	function printInsertMetadata() {
		echo "/*=================================================\n";
		echo "*           The MetaData\n";
		echo "*==================================================*/\n";
		foreach ($this->dict_OC as $oc) {
			echo "# Object Class: " . $oc->schema . "\n";
			echo $oc->metadataSQL;
		}
		if ($this->backsql_noAUX) {
			foreach ($this->dict_Attr as $attr) {
				echo "# Object Class: " . $attr->schema . "\n";
				echo $attr->metadataSQL;
			}
		}
	}
	function printCreateTable() {
		echo "/*=================================================\n";
		echo "*           ALL ObjectClasses Table\n";
		echo "*==================================================*/\n";
		foreach ($this->dict_OC as $oc) {
			echo "# Object Class: " . $oc->schema . "\n";
			echo $oc->tableSQL;
		}
		foreach ($this->dict_AUX as $oc) {
			echo "# Object Class: " . $oc->schema . "\n";
			echo $oc->tableSQL;
		}
		foreach ($this->dict_ABS as $oc) {
			echo "# Object Class: " . $oc->schema . "\n";
			echo $oc->tableSQL;
		}
		echo "\n\n\n";
		echo "/*=================================================\n";
		echo "*           ALL Attributies Table\n";
		echo "*==================================================*/\n";
		foreach ($this->dict_Attr as $attr) {
			echo "# Attribute: " . $attr->schema . "\n";
			echo $attr->tableSQL;
		}
	}
	function printOCFunctions() {
		echo "\n\n\n";
		echo "/*=================================================\n";
		echo "*           ALL Object Class FUNCTIONs\n";
		echo "*==================================================*/\n";
		foreach ($this->dict_OC as $oc) {
			echo $oc->functionSQL;
		}
	}
}
?>